#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

#define int long long
#define double long double

using namespace std;

void dfs1(int v,vector<vector<int>>& g, vector<int>& d, int prev, vector<int>& way, vector<int>& mway){
    for (int i = 0; i < g[v].size(); i++){
        if (g[v][i] == prev){
            continue;
        }
        d[g[v][i]] = d[v] + 1;
        way.push_back(g[v][i]);
        if (way.size() > mway.size()){
            mway = way;
        }
        dfs1(g[v][i], g, d, v, way, mway);
        way.pop_back();
    }
}

void solve1(int n, int k, int t, vector<vector<int>>& g){
    if (!t){
        int ans = n - 1;
        int m = 1;
        while(k >= m){
            ans = (ans + 1) / 2;
            k -= m;
            m *= 2;
        }
        cout << ans;
    }
    else{
        for (int i = 0; i < n; i++){
            int ans = max(n - 1, i);
            int m = 1;
            int k1 = k;
            while(k1 >= m){
                ans = (ans + 1) / 2;
                k1 -= m;
                m *= 2;
            }
            cout << ans << ' ';
        }
    }
};

void solve2(int n, int k, int t, vector<vector<int>>& g){
    vector<int> d(n);
    d[0] = 0;
    vector<int> way = {0};
    vector<int> mway = way;
    dfs1(0, g, d, -1, way, mway);
    g[mway[(mway.size()) / 2]].push_back(0);
    g[0].push_back(mway[(mway.size()) / 2]);
    vector<bool> used(n);
    used[0] = true;
    queue<int> q;
    q.push(0);
    d.clear();
    d.resize(n);
    for (int i = 1; i < n; i++){
        d[i] = 1e18;
    }
    d[0] = 0;
    int ans = 0;
    while(!q.empty()){
        auto v = q.front();
        q.pop();
        for (int i = 0; i < g[v].size(); i++){
            if (!used[g[v][i]]){
                d[g[v][i]] = d[v] + 1;
                ans = max(ans, d[g[v][i]]);
                q.push(g[v][i]);
                used[g[v][i]] = true;
            }
        }
    }
    cout << ans;
};

signed main() {
    int n, k, t;
    cin >> n >> k >> t;
    bool f = true;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++){
        int u, v;
        cin >> u >> v;
        if (!(u == i + 1 && v == i + 2)){
            f = false;
        }
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    if (f){
        solve1(n, k, t, g);
    }
    else{
        solve2(n, k, t, g);
    }
}