#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define int long long
#define double long double

using namespace std;

void dfs(int v, vector<vector<int>>& g, vector<bool>& vis, vector<bool>& a){
    vis[v] = true;
    for (auto to : g[v]){
        if (!vis[to]){
            a[to] = !a[v];
            dfs(to, g, vis, a);
        }
    }
}

signed main() {
    int n;
    cin >> n;
    vector<bool> a(1e6 + 1, false), p(1e6 + 1, true), used(1e6 + 1);
    p[1] = false;
    for (int i = 2; i <= 1e6; i++) {
        if (p[i]) {
            for (int j = i * 2; j <= 1e6; j += i) {
                p[j] = false;
            }
        }
    }
    vector<int> c(n);
    vector<vector<int>> g(1e6 + 1);
    for (int i = 0; i < n; i++){
        cin >> c[i];
    }
    vector<int> m = c;
    sort(m.begin(), m.end());
    for (int i = 0; i < n; i++){
        if (!used[m[i]]){
            used[m[i]] = true;
            for (int j = 1; j * j <= m[i]; j++){
                if (m[i] % j == 0 && p[m[i] / j] && used[m[i] / j]){
                    g[m[i]].push_back(j);
                    g[j].push_back(m[i]);
                }
            }
        }
    }
    vector<bool> vis(1e6 + 1, false);
    for (int i = 1; i <= 1e6; i++){
        if (!vis[i]){
            dfs(i, g, vis, a);
        }
    }
    for (auto i : c){
        if (a[i]){
            cout << 2;
        }
        else{
            cout << 1;
        }
        cout << ' ';
    }
}